/**********************************************
*  NTSC Color Monitor Contorol
*  FATt@CVXet
*  Project : NTSC4
**********************************************/
#include "p33FJ64GP802.h"
#include "MDD File System\FSIO.h"
#include "NTSC.h"
#include <stdlib.h>

/*** RtBM[Vݒ  ***/
_FOSCSEL(FNOSC_PRIPLL & IESO_OFF);		// Prim OSC
_FOSC(FCKSM_CSDCMD & IOL1WAY_OFF & OSCIOFNC_OFF & POSCMD_XT);
_FWDT(FWDTEN_OFF);
_FPOR(ALTI2C_OFF & FPWRT_PWR32);
_FICD(JTAGEN_OFF & ICS_PGD1);
/** t@CVXepϐ  **/
FSFILE *fptr;
size_t result;
SearchRec Record;
SearchRec *rptr = &Record;
char FileName[20][13];
unsigned char Buffer[300];
/** O[oϐ **/
int FileNo;
unsigned char Color;
/* \bZ[Wf[^ */
const char Msg1[] = "Wait Card Insert!";
const char Msg2[] = "Find Card OK!";
const char Msg3[] = "Find No File?";
const char Msg4[] = {0xED,0xEE,0x20,0x20,0xCC,0xA7,0xB2,0xD9,0xEF, 0};
/* vg^Cv */
unsigned int GetPOT(unsigned char chn);
void DispFiles(void);
int Select(void);
void CopyFile(int No);

/************************************************
* C֐
************************************************/
int main(void)
{
	OSCCON = 0x00300;					// PRIPLLw
	CLKDIV = 0;						// NbN̕1:2ɐݒ
	PLLFBD = 0x0026;					// 26{@8MHz2~402 = 80MHz/6=6.6MHz
	/** |[g̓o̓[hݒ */
	TRISA = 0x00FF;					// All input
	LATB  = 0x0000;					// 
	TRISB = 0xE00F;					// RB,0-3,13,14,15 input 
	/* SDJ[hpvAbv */
	CNPU1 = 0x38F1;					// CN0,4,5,6,7,11,12,13
	/* SDI,SDO,SCKst */
	RPINR22bits.SDI2R = 13;			// SDI2
	RPOR5bits.RP10R = 11;				// SCK2
	RPOR5bits.RP11R = 10;				// SDO2
	/* ADC̐ݒ */
	AD1CON1 = 0x0000;					// ADItA蓮
	AD1CON2 = 0;						// AVdd, AVss, MUXÂ
	AD1CON3 = 0x1F3F;					// 31Tad , Tad = 64*Tcy
	AD1CON4 = 0;						// 1word DMAobt@
	AD1CHS123 = 0;					// TvȂ
 	AD1CHS0 = 0x0000;					// `lI
	AD1PCFGL = 0xFFFC;				// RA0-1 only analog 
	AD1CSSL = 0;						// XLȂ
	AD1CON1bits.ADON = 1;				// ADL
	/*   */
	VideoInit();						// NTSCrfI䏉
	SRbits.IPL = 2;					// CPŮ荞݃xݒ


	/************* C[v  ****************/
	while(1)
	{
		AllClear(0);							// ʏ
		SetColor(WHITE);
		/**** J[h}܂ő҂t@CLmF ****/
		while(fptr == 0){		
			AllClear(0);						// ʏ
			if(!MDD_MediaDetect()){			// J[h}H
				SetColor(RED);
				PutStr(0, 0, Msg1);			// }҂bZ[W
			}
			else{		
				/*** t@CI[vƃt@C\ ***/
				PutStr(0, 1, Msg2);
				FSInit();					// FS
				/* ŏ̃t@C̃T[` */
				result = FindFirst("*.BMP", ATTR_ARCHIVE, rptr);
				if(result != 0){				// t@C肩H
					SetColor(YELLOW);
					PutStr(0, 2, Msg3);		// t@CbZ[W
				}
				else
					break;					// t@CŔ
			}
			delay_ms(500);					// 0.5bƂɌJԂ
		}
		/*** t@Cłꍇ̏ ***/
		DispFiles();							// t@Cꗗ\
		FileNo = Select();					// t@CI
		/** t@CRs[ĕ\ **/
		CopyFile(FileNo);					
		/** XN[̐ƃJ[ύX **/
		Color = 1;							// Fl
		while(MDD_MediaDetect()){				// J[h`FbN
			Scrole(5*GetPOT(0));				// XN[xݒ
			SetColor(Color);					// Fؑ
			Color++;
			if(Color > 7)						// FŌォH
				Color = 1;					// Fŏɖ߂
			delay_ms(6000);					// 10bƂɐFύX
		}
		ScrPitch = 0;							// XN[I
		ScrShift = 0;
		fptr = 0;							// t@C
	}
}

/***************************************************
*  t@CXg̕\
*  ő12t@CŐi\̂߁j
****************************************************/
void DispFiles(void){
	int i, j;

	AllClear(0);									// Sʏ
	/** o̕\  **/
	SetColor(GREEN);
	PutStr(0, 0, Msg4);							// o\
	Line(0, 16, 319, 16);							// d؂\
	/** t@C̕\ **/
	i = 1;										// |C^Zbg
	j = 0;
	/*** ŏ̃t@C̕\Ɗi[  ***/
	while(Record.filename[j] != 0){				// ̍ŌォH
		FileName[i][j] = Record.filename[j];		// i[
		j++;
	}
	PutStr(2, i++, Record.filename);				// \
	/** ׂẴt@C̕\Ɗi[ **/
	while(FindNext(rptr) == 0){					// ̃t@CT[`
		/*** t@CłΕ\i[  ***/
		j = 0;									// |C^Zbg
		if(Record.attributes==ATTR_ARCHIVE)			// łH
			while(Record.filename[j] != 0){		// ̂̍ŌォH
				FileName[i][j] = Record.filename[j];// i[
				j++;
			}
			PutStr(2, i++, Record.filename);		// t@C\
			if(i>=13)							// 13ڂ𒴂H
				break;							// IĔ
	}
}
	
/***********************************************
* t@CI
* w肳ꂽBMPt@C̃t@CԍԂ
***********************************************/
int Select(void){
	int i, Ptr;

	Ptr = 0;
	while(PORTBbits.RB2 != 0){					// EnterXCb``FbN 
		if(PORTAbits.RA4 == 0){				// SelectXCb``FbN
			Ptr++;							// ̍s
			for(i=1; i<=Ptr; i++)				// c̓Xy[X\
				PutChar(0, i, 0x20);			// Xy[Xŏ
			PutChar(0, Ptr, 0xE3);				// \
			if(Ptr > 12)						// ŏIsŐ擪ɖ߂
				Ptr = 0;
			while(PORTAbits.RA4 == 0);			// XCb`[X҂
			delay_ms(100);					// `b^O
		}
	}
	return(Ptr);								// sԍԂ
}

/*************************************************
* BMPt@C̓ǂݏoRs[
*   BMP̃f[^͉̃Cɕł
*************************************************/
void CopyFile(int No){
	int i, j;

	i = V_RES -1;									// ԉ̃Cw
	fptr = FSfopen(FileName[No], "r");				// t@CJ
	result = FSfread(Buffer, 1, 62, fptr);			// BMPwb_62oCgǂݔ΂
	/*** f[^̃CփRs[  ****/
	while(result != 0){							// ǂ񂾃f[^Rs[
		result = FSfread(Buffer, 1, 40, fptr);		// 1Cǂݏo
		for(j=0; j<result; j+=2){					// 2oCgPʂŃRs[
			VMem[i*20+j/2] = ((unsigned int)Buffer[j])*256 + (unsigned int)Buffer[j+1];
		}
		i--;										// ̃C
	}
	FSfclose(fptr);								// IŃt@C
}

/***************************************************
* POT̓
* 蓮TvOAϊJn
***************************************************/
unsigned int GetPOT(unsigned char chn)
{
	AD1CON1bits.ADON = 0;
	AD1CHS0 = chn;					// Select Channel
	AD1CON1bits.ADON = 1;
	AD1CON1bits.SAMP = 1;
	delay_us(10);						// Wait Aquisition
	AD1CON1bits.SAMP = 0;				// A/D convert start
	while(!AD1CON1bits.DONE);			// wait conversion
	return(ADC1BUF0);					// rturn result
}



